/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean5Newtypes

import Haskell5Newtypes

from StdEnv import qualified class zero (..), class + (..), class - (..)


:: NatC   =: NatC Int
:: FixC f =: InC (f (FixC f))

instance 'StdEnv'.zero NatC

instance 'StdEnv'. + NatC

instance 'StdEnv'. - NatC

helloNat :: NatH -> String
