/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean6TypeClasses

from StdEnv import not, &&


class EqC a where
  eqC :: a a -> Bool
  
  neqC x y :== not (eqC x y)

eqLC :: [a] [a] -> Bool | EqC a special a = Int; a = Bool

instance EqC [a] | EqC a        special a = Int; a = Bool

instance EqC a
