/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean8Monads


class Monad m where
  return         :: a -> m a
  (>>=) infixl 1 :: (m a) (a -> m b) -> m b

mapSMC :: (a -> m b) [a] -> m [b] | Monad m
