implementation module Data.IORef

import Prelude
from Prelude import qualified ::()

:: IORef a = {io_ref::!.(IORef_ a)}
:: IORef_ a = IORef_ !a

newIORef :: !a -> IO (IORef a)
newIORef a = IO (\w -> w`new_IO_ref a w)

readIORef :: !(IORef a) -> IO a
readIORef io_ref = IO (\w -> w`read_IO_ref io_ref w)

writeIORef :: !(IORef a) !a -> IO Prelude.`Unit
writeIORef io_ref a = IO (\w -> w`write_IO_ref io_ref a w)

modifyIORef :: !(IORef a) !(a -> a) -> IO Prelude.`Unit
modifyIORef io_ref f = IO (\w -> w`modify_IO_ref io_ref f w)

w`new_IO_ref :: !a !*World -> (!IORef a,!*World)
w`new_IO_ref a w = ({io_ref=IORef_ a},w)

w`read_IO_ref :: !(IORef a) !*World -> (!a,!*World)
w`read_IO_ref {io_ref=IORef_ a} w = (a,w)

w`write_IO_ref :: !(IORef a) !a !*World -> (!Prelude.`Unit,!*World)
w`write_IO_ref io_ref a w = code inline {
	push_a 1
	fill1_r k17 1 0 1 01
	.keep 0 2
	pop_a 2
	buildh e_PreludeTypes_d`Unit 0
 }

w`modify_IO_ref :: !(IORef a) !(a -> a) !*World -> (!Prelude.`Unit,!*World)
w`modify_IO_ref io_ref=:{io_ref=IORef_ a} f w
	= w`write_IO_ref io_ref (f a) w
