definition module Foreign.C.String

from PreludeTypes import qualified ::IO
from Foreign.C.Types import qualified ::CChar
from Foreign.Ptr import qualified ::Ptr

:: CString :== Foreign.Ptr.Ptr Foreign.C.Types.CChar
:: CStringLen :== (Foreign.Ptr.Ptr Foreign.C.Types.CChar,Int)

withCString :: ![Char] !(CString -> PreludeTypes.IO a) -> PreludeTypes.IO a
withCStringLen :: ![Char] !(CStringLen -> PreludeTypes.IO a) -> PreludeTypes.IO a
withCAStringLen :: ![Char] !(CStringLen -> PreludeTypes.IO a) -> PreludeTypes.IO a
peekCString :: !CString -> PreludeTypes.IO [Char]
peekCStringLen :: !CStringLen -> PreludeTypes.IO [Char]
peekCAStringLen :: !CStringLen -> PreludeTypes.IO [Char]
