definition module PackedString where

from PreludeTypes import :: String,class Eq,class Ord,class Show

:: PackedString:==`String

packString :: !String -> PackedString
unpackPS :: !PackedString -> String

instance Eq PackedString where
	(==) :: !PackedString -> !PackedString -> Bool
	(/=) :: !PackedString -> !PackedString -> Bool

instance Ord PackedString where
	(<) :: !PackedString -> !PackedString -> Bool
	(>) :: !PackedString -> !PackedString -> Bool
	(<=) :: !PackedString -> !PackedString -> Bool
	(>=) :: !PackedString -> !PackedString -> Bool

instance Show PackedString
