/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean10Arrays

from StdEnv import qualified class Array (..), class Eq (..)


zeroes :: Int -> .(a Int) | 'StdEnv'.Array a Int

fibs10 ::        .(a Int) | 'StdEnv'.Array a Int

fibs   :: Int -> .(a Int) | 'StdEnv'.Array a Int

fib :: !Int -> Int

fibs2 :: Int -> {Int}

isPalindrome :: {e} -> Bool | 'StdEnv'.Eq e
