/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
definition module Clean11DynamicTyping

from StdMaybe import qualified :: Maybe


wrapInt :: Int -> Dynamic

unwrapInt :: Dynamic -> Int

wrapC :: a -> Dynamic | TC a

unwrapC :: Dynamic -> 'StdMaybe'.Maybe a | TC a
