/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean5Newtypes

import Haskell5Newtypes

import StdEnv


instance zero NatC where 
  zero = NatC zero

instance + NatC where 
  + (NatC x) (NatC y) = NatC (x + y)

instance - NatC where 
  - (NatC x) (NatC y) = NatC (max zero (x - y))

helloNat :: NatH -> String
helloNat (NatH x) = "Hello world!"