definition module Data.IORef hiding (::IORef_)

from PreludeTypes import qualified ::IO,::()

:: IORef a = {io_ref::!.(IORef_ a)}
:: IORef_ a

newIORef :: !a -> PreludeTypes.IO (IORef a)
readIORef :: !(IORef a) -> PreludeTypes.IO a
writeIORef :: !(IORef a) !a -> PreludeTypes.IO PreludeTypes.`Unit
modifyIORef :: !(IORef a) !(a -> a) -> PreludeTypes.IO PreludeTypes.`Unit

from Prelude import IO

io`newIORef a :== IO (\w -> w`new_IO_ref a w)
io`readIORef io_ref :== IO (\w->w`read_IO_ref io_ref w)
io`writeIORef io_ref a :== IO (\w->w`write_IO_ref io_ref a w)
io`modifyIORef io_ref f :== IO (\w -> w`modify_IO_ref io_ref f w)

w`new_IO_ref :: !a !*World -> (!IORef a,!*World)
w`read_IO_ref :: !(IORef a) !*World -> (!a,!*World)
w`write_IO_ref :: !(IORef a) !a !*World -> (!PreludeTypes.`Unit,!*World)
w`modify_IO_ref :: !(IORef a) !(a -> a) !*World -> (!PreludeTypes.`Unit,!*World)
