definition module Foreign.Marshal.Array

from PreludeTypes import qualified ::IO,::()
from Foreign.Ptr import qualified ::Ptr
from Foreign.Storable import qualified class Storable
from Data.Int import qualified ::Int32
from Data.Word import qualified ::Word8

allocaArray :: !Int !((Foreign.Ptr.Ptr a) -> PreludeTypes.IO b) -> PreludeTypes.IO b | Foreign.Storable.Storable a
	special a=Data.Word.Word8
			a=Data.Int.Int32
withArray :: ![a] !((Foreign.Ptr.Ptr a) -> PreludeTypes.IO b) -> PreludeTypes.IO b | Foreign.Storable.Storable a
	special a=Data.Word.Word8
			a=Data.Int.Int32
withArrayLen :: ![a] !(Int -> (Foreign.Ptr.Ptr a) -> PreludeTypes.IO b) -> PreludeTypes.IO b | Foreign.Storable.Storable a
	special a=Data.Word.Word8
			a=Data.Int.Int32
pokeArray :: !(Foreign.Ptr.Ptr a) ![a] -> PreludeTypes.IO PreludeTypes.`Unit | Foreign.Storable.Storable a
	special a=Data.Word.Word8
			a=Data.Int.Int32
peekArray :: !Int !(Foreign.Ptr.Ptr a) -> PreludeTypes.IO [a] | Foreign.Storable.Storable a
	special a=Data.Word.Word8
			a=Data.Int.Int32
