definition module PreludeInternalIOError where

data IOError
	= DoesNotExistError
	| AlreadyExistsError
	| PermissionError
	| EOFError
	| FullError
	| IllegalOperationError
	| UserError [Char]

ioeGetError`String :: !IOError -> {#Char}
