implementation module PreludeInternalIOError where

import PreludeInternal (char_list_to_string)

ioeGetError`String :: !IOError -> {#Char}
ioeGetError`String DoesNotExistError = `"does not exist "
ioeGetError`String AlreadyExistsError = `"already exists "
ioeGetError`String PermissionError = `"permission denied"
ioeGetError`String EOFError = `"end of file"
ioeGetError`String FullError = `"resource exhausted"
ioeGetError`String IllegalOperationError = `"illegal operation"
ioeGetError`String (UserError str) = char_list_to_string str
