implementation module PreludeTuples where

instance (Eq e0,Eq e1) =>
  Eq (e0,e1) where
  	(==) :: (Eq e0,Eq e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) == (b0,b1) = a0==b0 && a1==b1
  	(/=) :: (Eq e0,Eq e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) /= (b0,b1) = a0/=b0 || a1/=b1

instance (Eq e0,Eq e1,Eq e2) =>
  Eq (e0,e1,e2) where
  	(==) :: (Eq e0,Eq e1,Eq e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) == (b0,b1,b2) = a0==b0 && a1==b1 && a2==b2
  	(/=) :: (Eq e0,Eq e1,Eq e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) /= (b0,b1,b2) = a0/=b0 || a1/=b1 || a2/=b2

instance (Eq e0,Eq e1,Eq e2,Eq e3) =>
  Eq (e0,e1,e2,e3) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) == (b0,b1,b2,b3) = a0==b0 && a1==b1 && a2==b2 && a3==b3
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) /= (b0,b1,b2,b3) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4) =>
  Eq (e0,e1,e2,e3,e4) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) == (b0,b1,b2,b3,b4) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) /= (b0,b1,b2,b3,b4) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5) =>
  Eq (e0,e1,e2,e3,e4,e5) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) == (b0,b1,b2,b3,b4,b5) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) /= (b0,b1,b2,b3,b4,b5) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6) =>
  Eq (e0,e1,e2,e3,e4,e5,e6) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) == (b0,b1,b2,b3,b4,b5,b6) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) /= (b0,b1,b2,b3,b4,b5,b6) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) == (b0,b1,b2,b3,b4,b5,b6,b7) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) /= (b0,b1,b2,b3,b4,b5,b6,b7) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) == (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9 && a10==b10
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9 || a10/=b10

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9 && a10==b10 && a11==b11
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9 || a10/=b10 || a11/=b11

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9 && a10==b10 && a11==b11 && a12==b12
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9 || a10/=b10 || a11/=b11 || a12/=b12

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9 && a10==b10 && a11==b11 && a12==b12 && a13==b13
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9 || a10/=b10 || a11/=b11 || a12/=b12 || a13/=b13

instance (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13,Eq e14) =>
  Eq (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) where
  	(==) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13,Eq e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) == (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0==b0 && a1==b1 && a2==b2 && a3==b3 && a4==b4 && a5==b5 && a6==b6 && a7==b7 && a8==b8 && a9==b9 && a10==b10 && a11==b11 && a12==b12 && a13==b13 && a14==b14
  	(/=) :: (Eq e0,Eq e1,Eq e2,Eq e3,Eq e4,Eq e5,Eq e6,Eq e7,Eq e8,Eq e9,Eq e10,Eq e11,Eq e12,Eq e13,Eq e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) /= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0/=b0 || a1/=b1 || a2/=b2 || a3/=b3 || a4/=b4 || a5/=b5 || a6/=b6 || a7/=b7 || a8/=b8 || a9/=b9 || a10/=b10 || a11/=b11 || a12/=b12 || a13/=b13 || a14/=b14

instance (Ord e0,Ord e1) =>
  Ord (e0,e1) where
  	(<) :: (Ord e0,Ord e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) < (b0,b1) = a0<b0 || (a0==b0 && a1<b1)
  	(>) :: (Ord e0,Ord e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) > (b0,b1) = a0>b0 || (a0==b0 && a1>b1)
  	(>=) :: (Ord e0,Ord e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) >= (b0,b1) = a0>b0 || (a0==b0 && a1>=b1)
  	(<=) :: (Ord e0,Ord e1) => !(e0,e1) -> !(e0,e1) -> Bool
	(a0,a1) <= (b0,b1) = a0<b0 || (a0==b0 && a1<=b1)

instance (Ord e0,Ord e1,Ord e2) =>
  Ord (e0,e1,e2) where
  	(<) :: (Ord e0,Ord e1,Ord e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) < (b0,b1,b2) = a0<b0 || (a0==b0 && (a1,a2)<(b1,b2))
  	(>) :: (Ord e0,Ord e1,Ord e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) > (b0,b1,b2) = a0>b0 || (a0==b0 && (a1,a2)>(b1,b2))
  	(>=) :: (Ord e0,Ord e1,Ord e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) >= (b0,b1,b2) = a0>b0 || (a0==b0 && (a1,a2)>=(b1,b2))
  	(<=) :: (Ord e0,Ord e1,Ord e2) => !(e0,e1,e2) -> !(e0,e1,e2) -> Bool
	(a0,a1,a2) <= (b0,b1,b2) = a0<b0 || (a0==b0 && (a1,a2)<=(b1,b2))

instance (Ord e0,Ord e1,Ord e2,Ord e3) =>
  Ord (e0,e1,e2,e3) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) < (b0,b1,b2,b3) = a0<b0 || (a0==b0 && (a1,a2,a3)<(b1,b2,b3))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) > (b0,b1,b2,b3) = a0>b0 || (a0==b0 && (a1,a2,a3)>(b1,b2,b3))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) >= (b0,b1,b2,b3) = a0>b0 || (a0==b0 && (a1,a2,a3)>=(b1,b2,b3))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3) => !(e0,e1,e2,e3) -> !(e0,e1,e2,e3) -> Bool
	(a0,a1,a2,a3) <= (b0,b1,b2,b3) = a0<b0 || (a0==b0 && (a1,a2,a3)<=(b1,b2,b3))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4) =>
  Ord (e0,e1,e2,e3,e4) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) < (b0,b1,b2,b3,b4) = a0<b0 || (a0==b0 && (a1,a2,a3,a4)<(b1,b2,b3,b4))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) > (b0,b1,b2,b3,b4) = a0>b0 || (a0==b0 && (a1,a2,a3,a4)>(b1,b2,b3,b4))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) >= (b0,b1,b2,b3,b4) = a0>b0 || (a0==b0 && (a1,a2,a3,a4)>=(b1,b2,b3,b4))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4) => !(e0,e1,e2,e3,e4) -> !(e0,e1,e2,e3,e4) -> Bool
	(a0,a1,a2,a3,a4) <= (b0,b1,b2,b3,b4) = a0<b0 || (a0==b0 && (a1,a2,a3,a4)<=(b1,b2,b3,b4))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5) =>
  Ord (e0,e1,e2,e3,e4,e5) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) < (b0,b1,b2,b3,b4,b5) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5)<(b1,b2,b3,b4,b5))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) > (b0,b1,b2,b3,b4,b5) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5)>(b1,b2,b3,b4,b5))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) >= (b0,b1,b2,b3,b4,b5) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5)>=(b1,b2,b3,b4,b5))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5) => !(e0,e1,e2,e3,e4,e5) -> !(e0,e1,e2,e3,e4,e5) -> Bool
	(a0,a1,a2,a3,a4,a5) <= (b0,b1,b2,b3,b4,b5) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5)<=(b1,b2,b3,b4,b5))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6) =>
  Ord (e0,e1,e2,e3,e4,e5,e6) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) < (b0,b1,b2,b3,b4,b5,b6) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6)<(b1,b2,b3,b4,b5,b6))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) > (b0,b1,b2,b3,b4,b5,b6) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6)>(b1,b2,b3,b4,b5,b6))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) >= (b0,b1,b2,b3,b4,b5,b6) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6)>=(b1,b2,b3,b4,b5,b6))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6) => !(e0,e1,e2,e3,e4,e5,e6) -> !(e0,e1,e2,e3,e4,e5,e6) -> Bool
	(a0,a1,a2,a3,a4,a5,a6) <= (b0,b1,b2,b3,b4,b5,b6) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6)<=(b1,b2,b3,b4,b5,b6))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) < (b0,b1,b2,b3,b4,b5,b6,b7) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7)<(b1,b2,b3,b4,b5,b6,b7))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) > (b0,b1,b2,b3,b4,b5,b6,b7) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7)>(b1,b2,b3,b4,b5,b6,b7))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) >= (b0,b1,b2,b3,b4,b5,b6,b7) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7)>=(b1,b2,b3,b4,b5,b6,b7))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7) => !(e0,e1,e2,e3,e4,e5,e6,e7) -> !(e0,e1,e2,e3,e4,e5,e6,e7) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7) <= (b0,b1,b2,b3,b4,b5,b6,b7) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7)<=(b1,b2,b3,b4,b5,b6,b7))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) < (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8)<(b1,b2,b3,b4,b5,b6,b7,b8))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) > (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8)>(b1,b2,b3,b4,b5,b6,b7,b8))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8)>=(b1,b2,b3,b4,b5,b6,b7,b8))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8)<=(b1,b2,b3,b4,b5,b6,b7,b8))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9)<(b1,b2,b3,b4,b5,b6,b7,b8,b9))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9)>(b1,b2,b3,b4,b5,b6,b7,b8,b9))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)<(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)>(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)<(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)>(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)<(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)>(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)<(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)>(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13))

instance (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13,Ord e14) =>
  Ord (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) where
  	(<) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13,Ord e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) < (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)<(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14))
  	(>) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13,Ord e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) > (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)>(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14))
  	(>=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13,Ord e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) >= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0>b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)>=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14))
  	(<=) :: (Ord e0,Ord e1,Ord e2,Ord e3,Ord e4,Ord e5,Ord e6,Ord e7,Ord e8,Ord e9,Ord e10,Ord e11,Ord e12,Ord e13,Ord e14) => !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> !(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) -> Bool
	(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14) <= (b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14) = a0<b0 || (a0==b0 && (a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)<=(b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14))

instance (Bounded e0,Bounded e1) =>
  Bounded (e0,e1) where
  	minBound = (minBound,minBound)
  	maxBound = (maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2) =>
  Bounded (e0,e1,e2) where
  	minBound = (minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3) =>
  Bounded (e0,e1,e2,e3) where
  	minBound = (minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4) =>
  Bounded (e0,e1,e2,e3,e4) where
  	minBound = (minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5) =>
  Bounded (e0,e1,e2,e3,e4,e5) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9,Bounded e10) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9,Bounded e10,Bounded e11) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9,Bounded e10,Bounded e11,Bounded e12) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9,Bounded e10,Bounded e11,Bounded e12,Bounded e13) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

instance (Bounded e0,Bounded e1,Bounded e2,Bounded e3,Bounded e4,Bounded e5,Bounded e6,Bounded e7,Bounded e8,Bounded e9,Bounded e10,Bounded e11,Bounded e12,Bounded e13,Bounded e14) =>
  Bounded (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) where
  	minBound = (minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound,minBound)
  	maxBound = (maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound,maxBound)

