implementation module PreludeTypes where

newtype IO a = IO (*World -> *(a,!*World))

io_to_f (IO io) :== io;
//io_to_f io :== let (IO f) = io in f;

f_to_io f :== IO f;

/*
:: IO a :== *World -> *(a,*World)

io_to_f :: !(IO a) -> (*World -> *(a,*World));
io_to_f io = io;

f_to_io :: !(*World -> *(a,*World)) -> IO a;
f_to_io f = f;
*/

from StdList import ++

null :: ![a] -> Bool
null [] = True
null (_:_) = False

showChar :: Char -> String -> String
showChar c s = c:s

showString :: !String -> String -> String
showString s1 s2 = s1++s2

//shows :: (Show a) => a -> String -> String
shows s t :== showsPrec `0 s t

//reads :: (Read a) => ReadS a
reads :== readsPrec `0

skip_spaces` :: !String -> String
skip_spaces` (' ':s) = skip_spaces` s
skip_spaces` ('\t':s) = skip_spaces` s
skip_spaces` ('\n':s) = skip_spaces` s
skip_spaces` ('\r':s) = skip_spaces` s
skip_spaces` ('\f':s) = skip_spaces` s
skip_spaces` ('\v':s) = skip_spaces` s
skip_spaces` s = s
