definition module Time

from PreludeTypes import qualified
  :: String
 ,:: Integer
 ,:: Ordering
 ,:: IO
 ,class Eq
 ,class Ord
 ,class Enum
 ,class Bounded
 ,class Show
 ,class Read
 ,class Ix
from Locale import qualified
  :: TimeLocale
:: Month
 = January 
 | February 
 | March 
 | April 
 | May 
 | June 
 | July 
 | August 
 | September 
 | October 
 | November 
 | December 
:: Day
 = Sunday 
 | Monday 
 | Tuesday 
 | Wednesday 
 | Thursday 
 | Friday 
 | Saturday 
:: CalendarTime
 = CalendarTime { ctYear :: Int,ctMonth :: Month,ctDay :: Int,ctHour :: Int,ctMin :: Int,ctSec :: Int,ctPicosec :: PreludeTypes.Integer,ctWDay :: Day,ctYDay :: Int,ctTZName :: PreludeTypes.String,ctTZ :: Int,ctIsDST :: Bool}
:: TimeDiff
 = TimeDiff { tdYear :: Int,tdMonth :: Int,tdDay :: Int,tdHour :: Int,tdMin :: Int,tdSec :: Int,tdPicosec :: PreludeTypes.Integer}
:: ClockTime
 = ! { ct_milli_sec_l :: !Int,ct_milli_sec_h :: !Int,ct_pico_sec :: !Int }
instance PreludeTypes.Eq Month where
  (/=) infix 4 :: !Month Month -> Bool
  (==) infix 9 :: !Month Month -> Bool
instance PreludeTypes.Ord Month where
  (<) infix 4 :: !Month !Month -> Bool
  (<=) infix 4 :: !Month !Month -> Bool
  (>) infix 4 :: !Month !Month -> Bool
  (>=) infix 4 :: !Month !Month -> Bool
  compare :: !Month !Month -> PreludeTypes.Ordering
  max :: !Month !Month -> Month
  min :: !Month !Month -> Month
instance PreludeTypes.Enum Month where
  enumFrom :: !Month -> [Month]
  enumFromThen :: !Month !Month -> [Month]
  enumFromThenTo :: !Month !Month !Month -> [Month]
  enumFromTo :: !Month !Month -> [Month]
  fromEnum :: !Month -> Int
  pred :: (Month -> Month)
  succ :: (Month -> Month)
  toEnum :: !Int -> Month
instance PreludeTypes.Bounded Month where
  maxBound :: Month
  minBound :: Month
instance PreludeTypes.Ix Month where
  inRange :: !(!Month,Month) !Month -> Bool
  index :: !(!Month,!Month) !Month -> Int
  range :: !(!Month,!Month) -> [Month]
  rangeSize :: !(!Month,!Month) -> Int
instance PreludeTypes.Read Month where
  readList :: ([Char] -> [([Month],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(Month,[Char])]]
  readsPrec :: Int -> [Char] -> [(Month,[Char])]
instance PreludeTypes.Show Month where
  show :: !Month -> [Char]
  showList :: ![Month] -> [Char] -> [Char]
  showsPrec :: Int !Month -> [Char] -> [Char]
instance PreludeTypes.Eq Day where
  (/=) infix 4 :: !Day Day -> Bool
  (==) infix 9 :: !Day Day -> Bool
instance PreludeTypes.Ord Day where
  (<) infix 4 :: !Day !Day -> Bool
  (<=) infix 4 :: !Day !Day -> Bool
  (>) infix 4 :: !Day !Day -> Bool
  (>=) infix 4 :: !Day !Day -> Bool
  compare :: !Day !Day -> PreludeTypes.Ordering
  max :: !Day !Day -> Day
  min :: !Day !Day -> Day
instance PreludeTypes.Enum Day where
  enumFrom :: !Day -> [Day]
  enumFromThen :: !Day !Day -> [Day]
  enumFromThenTo :: !Day !Day !Day -> [Day]
  enumFromTo :: !Day !Day -> [Day]
  fromEnum :: !Day -> Int
  pred :: (Day -> Day)
  succ :: (Day -> Day)
  toEnum :: !Int -> Day
instance PreludeTypes.Bounded Day where
  maxBound :: Day
  minBound :: Day
instance PreludeTypes.Ix Day where
  inRange :: !(!Day,Day) !Day -> Bool
  index :: !(!Day,!Day) !Day -> Int
  range :: !(!Day,!Day) -> [Day]
  rangeSize :: !(!Day,!Day) -> Int
instance PreludeTypes.Read Day where
  readList :: ([Char] -> [([Day],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(Day,[Char])]]
  readsPrec :: Int -> [Char] -> [(Day,[Char])]
instance PreludeTypes.Show Day where
  show :: !Day -> [Char]
  showList :: ![Day] -> [Char] -> [Char]
  showsPrec :: Int !Day -> [Char] -> [Char]
instance PreludeTypes.Eq CalendarTime where
  (/=) infix 4 :: !CalendarTime !CalendarTime -> Bool
  (==) infix 9 :: !CalendarTime !CalendarTime -> Bool
instance PreludeTypes.Ord CalendarTime where
  (<) infix 4 :: !CalendarTime !CalendarTime -> Bool
  (<=) infix 4 :: !CalendarTime !CalendarTime -> Bool
  (>) infix 4 :: !CalendarTime !CalendarTime -> Bool
  (>=) infix 4 :: !CalendarTime !CalendarTime -> Bool
  compare :: !CalendarTime !CalendarTime -> PreludeTypes.Ordering
  max :: !CalendarTime !CalendarTime -> CalendarTime
  min :: !CalendarTime !CalendarTime -> CalendarTime
instance PreludeTypes.Read CalendarTime where
  readList :: ([Char] -> [([CalendarTime],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(CalendarTime,[Char])]]
  readsPrec :: Int -> [Char] -> [(CalendarTime,[Char])]
instance PreludeTypes.Show CalendarTime where
  show :: !CalendarTime -> [Char]
  showList :: ![CalendarTime] -> [Char] -> [Char]
  showsPrec :: !Int !CalendarTime -> [Char] -> [Char]
instance PreludeTypes.Eq TimeDiff where
  (/=) infix 4 :: !TimeDiff !TimeDiff -> Bool
  (==) infix 9 :: !TimeDiff !TimeDiff -> Bool
instance PreludeTypes.Ord TimeDiff where
  (<) infix 4 :: !TimeDiff !TimeDiff -> Bool
  (<=) infix 4 :: !TimeDiff !TimeDiff -> Bool
  (>) infix 4 :: !TimeDiff !TimeDiff -> Bool
  (>=) infix 4 :: !TimeDiff !TimeDiff -> Bool
  compare :: !TimeDiff !TimeDiff -> PreludeTypes.Ordering
  max :: !TimeDiff !TimeDiff -> TimeDiff
  min :: !TimeDiff !TimeDiff -> TimeDiff
instance PreludeTypes.Read TimeDiff where
  readList :: ([Char] -> [([TimeDiff],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(TimeDiff,[Char])]]
  readsPrec :: Int -> [Char] -> [(TimeDiff,[Char])]
instance PreludeTypes.Show TimeDiff where
  show :: !TimeDiff -> [Char]
  showList :: ![TimeDiff] -> [Char] -> [Char]
  showsPrec :: !Int !TimeDiff -> [Char] -> [Char]
instance PreludeTypes.Eq ClockTime where
  (/=) infix 9 :: !ClockTime !ClockTime -> Bool
  (==) infix 9 :: !ClockTime !ClockTime -> Bool
instance PreludeTypes.Ord ClockTime where
  (<) infix 9 :: !ClockTime !ClockTime -> Bool
  (<=) infix 9 :: !ClockTime !ClockTime -> Bool
  (>) infix 9 :: !ClockTime !ClockTime -> Bool
  (>=) infix 9 :: !ClockTime !ClockTime -> Bool
  compare :: !ClockTime !ClockTime -> PreludeTypes.Ordering
  max :: !ClockTime !ClockTime -> ClockTime
  min :: !ClockTime !ClockTime -> ClockTime
getClockTime :: PreludeTypes.IO ClockTime
toCalendarTime :: !ClockTime -> PreludeTypes.IO CalendarTime
toUTCTime :: !ClockTime -> CalendarTime
toClockTime :: !CalendarTime -> ClockTime
localCalendarTimeToClockTime` :: !CalendarTime -> PreludeTypes.IO ClockTime
addToClockTime :: !TimeDiff !ClockTime -> ClockTime
diffClockTimes :: !ClockTime !ClockTime -> TimeDiff
calendarTimeToString :: !CalendarTime -> [Char]
formatCalendarTime :: Locale.TimeLocale ![Char] !CalendarTime -> [Char]
